*: BOF: ARCHIVE.PRG - A custom class for file compression/decompression
* Copyright 1999 by Vic McClung- vicmc@honors.semo.edu
* The latest version of this program can be downloaded from:
* http://members.xoom.com/vicmc
* SEE ARCHIVE.DOC for documentation
* archive custom class
* uses unlha.dll for 16 bit and
* unlha32.dll for 32 bit
* works with Visual dBASE 5.7 and
* Visual dBASE 7.x
*
#ifdef __vdb__
   #include "vdbase.h"
#else
   #include "messdlg.h"
#endif

#define M_ERROR_MESSAGE_ON       htoi('00400000')
#define M_NOT_USE_DRIVE_LETTER   htoi('00002000')
#define M_CHECK_FILENAME_ONLY    htoi('00000200')

#define test

#ifdef test3
arc = new archive('idapi.pak')
arc.MakeSFX()
arc.release()
arc = null
#endif

#ifdef test2
arc = new archive('idapi.pak')
aList = arc.listFiles()
clear
for i = 1 to aList.size
   ? aList[i]
next
#endif

#ifdef test1
* clear
set talk off
shell(.f., .f.)
aFiles = {'c:\idapi\*.*'}
a = new archive('idapi.pak')
a.nTime = .1
a.addFiles(aFiles)
a = new archive('langdrv.pak')
a.nTime = .1
aFiles = {'c:\idapi\langdrv\*.ld'}
a.addFiles(aFiles)
a.release()
a = null
#endif


class archive(arcFile)
   GetAPI()
   this.archivefile = arcFile
   this.sourcedir = ""
   this.targetdir = ""
   this.command = "l"
   this.switches = "-ny"
   this.filename = ""
   this.windowtext = ""
   this.commandline = ""
   this.nTime = .05

   Procedure MakeSFX
   local nResults, cCommand, arcfile, cDir, buffer, cFile
   * this method creates a self-extracting archive from
   * a file compressed with unlha/unlha32
   buffer = space(200)
   UnlhaSetCursorMode(.f.)
   arcfile = this.archivefile
   cDir = this.sourcedir
   this.command = 's'
   cCommand = this.command
   cFile = ""
   #ifdef __vdb__
      nResults = Unlha(0, cCommand+' -ny '+arcfile+' '+cDir+' '+cFile, buffer, len(buffer))
   #else
      nResults = Unlha(cCommand+' -ny '+arcfile+' '+cDir+' '+cFile, buffer, len(buffer))
   #endif
   if nResults # 0
      ? chr(7)
      AlertMessage('Error Building SFX File!', 'Error')
      exit
   endif

   Procedure release
   release object this

   procedure listFiles(cFileName)
   local aFiles, nFiles, h, sINFO, nResults, i, cFile
   local cArcFile
   if pcount() == 0
      cFileName = '*.*'
   endif
   UnlhaSetCursorMode(.f.)
   cArcFile = this.archivefile
   nFiles = UnlhaGetFileCount(cArcFile)
   if nFiles < 1
      ? chr(7)
      AlertMessage('Error Obtaining File Count!','Error')
      return {""}
   endif
   aFiles = new array(nFiles)
   h = UnlhaOpenArchive(0, cArcFile, M_ERROR_MESSAGE_ON)
   if h == 0
      ? chr(7)
      AlertMessage('Error Opening Archive!', 'Error')
      return {""}
   endif
   #ifdef __vdb__
      sINFO = space(558/2)
   #else
      sINFO = space(164)
   #endif
   nResults = UnlhaFindFirst(h, cFileName, sInfo)
   #ifdef __vdb__
      aFiles[1] = this.GetString(sInfo)
   #else
      aFiles[1] = substr(sInfo, 1, at(chr(0), sINFO)-1)
   #endif
   for i = 2 to nFiles
      nResults = UnlhaFindNext(h, sInfo)
      #ifdef __vdb__
         aFiles[i] = this.GetString(sINFO)
      #else
         aFiles[i] = substr(sInfo, 1, at(chr(0), sINFO)-1)
      #endif
   next
   UnlhaCloseArchive(h)
   return aFiles

   function GetString(s)
   local cStr; cStr = ""
   local i; i = 26
   local c
   do while .t.
      c = s.getbyte(i)
      if c == 0
         exit
      endif
      cStr = cStr + chr(c)
      i = i + 1
   enddo
   return cStr

   procedure addFiles(aFiles)
   local i, nFiles, buffer, cFile, f1, aList
   local nResults, arcfile, cdir, cCommand
   this.command = 'a'
   cCommand = this.command
   f1 = new progress1()
   if empty(this.windowtext)
      f1.text = 'Compressing Files...'
   else
      f1.text = this.windowtext
   endif
   f1.txtfilename.text = ""
   f1.text2.text = 'Compressing File:'
   f1.open()
   buffer = space(200)
   UnlhaSetCursorMode(.f.)
   arcfile = this.archivefile
   cDir = this.sourcedir
   if aFiles.size == 1
      if '*' $ aFiles[1] .or. '?' $ aFiles[1]
         if "\" $ aFiles[1]
            cDir = substr(aFiles[1], 1, rat('\', aFiles[1]))
            aFiles[1] = substr(aFiles[1], len(cDir)+1)
         endif
         aList = new array()
         aList.dir(cDir+aFiles[1])
         nFiles = aList.size/5
         aFiles = new array(nFiles)
         for i = 1 to nFiles
            aFiles[i] = cDir+aList[i, 1]
         next
      endif
   endif
   nFiles = aFiles.size
   f1.ProgressBar1.SetUp(nFiles)
   for i = 1 to nFiles
      cFile = aFiles[i]
      f1.txtfilename.text = cFile
      #ifdef __vdb__
         nResults = Unlha(0, cCommand+' -ny '+arcfile+' '+cDir+' '+cFile, buffer, len(buffer))
      #else
         nResults = Unlha(cCommand+' -ny '+arcfile+' '+cDir+' '+cFile, buffer, len(buffer))
      #endif
      if nResults # 0
         ? chr(7)
         AlertMessage('Error adding File to Archive!', 'Error')
         exit
      endif
      if f1.lCancel
         exit
      endif
      f1.ProgressBar1.UpDate(i)
      inkey(this.nTime)
   next
   f1.close()
   f1.release()
   f1 = null
   return

   procedure extractFiles(aFiles)
   * this method must receive an array of filename, directory pairs in
   * the array aFiles, i.e. {'filename', 'c:\dir\subdir\'}
   * the directory must end in '\' or ':' (c:)
   * the filename can contain wildcards, i.e. '*.*' or '?ilename.*'
   * if the directory portion is empty (""), the targetdir property is used
   * if this.targetdir is empty, the files are extracted to the current
   * directory
   local nFiles, nResults, i, cFile, cArchive, cDest
   local buffer, f1, aList, cCommand
   UnlhaSetCursorMode(.f.)
   buffer = space(200)
   this.command = 'e'
   cCommand = this.command
   f1 = new progress1()
   if empty(this.windowtext)
      f1.text = 'Extracting Files...'
   else
      f1.text = this.windowtext
   endif
   f1.txtfilename.text = ""
   f1.text2.text = 'Extracting File:'
   f1.open()
   cDir = this.targetdir
   if aFiles.size == 2
      if '*' $ aFiles[1] .or. '?' $ aFiles[1]
         if .not. empty(aFiles[2])
            cDir = aFiles[2]
         endif
         aList = class::listFiles(aFiles[1])
         aFiles = new array(aList.size, 2)
         for i = 1 to aFiles.size/2
            aFiles[i, 1] = aList[i]
            aFiles[i, 2] = cDir
         next
      endif
   endif
   nFiles = aFiles.size/2
   cArchive = this.archivefile
   f1.ProgressBar1.SetUp(nFiles)
   for i = 1 to nFiles
      cFile = aFiles[i, 1]
      cDest = aFiles[i, 2]
      f1.txtfilename.text = cDest+cFile
      #ifdef __vdb__
         nResults = Unlha(0, cCommand+' -ny '+cArchive+' '+cDest+' '+cFile , buffer, len(buffer))
      #else
         nResults = Unlha(cCommand+' -ny '+cArchive+' '+cDest+' '+cFile , buffer, len(buffer))
      #endif
      if nResults # 0
         ? chr(7)
         AlertMessage('Error extracting File from Archive!', 'Error')
         exit
      endif
      if f1.lCancel
         exit
      endif
      f1.ProgressBar1.UpDate(i)
      inkey(this.nTime)
   next
   f1.close()
   f1.release()
   f1 = null
   return

endclass

#ifdef __vdb__

class progress1 of FORM
   with (this)
      onOpen = class::FORM_ONOPEN
      scaleFontBold = false
      height = 4.9545
      left = 38.8571
      top = 2.2727
      width = 44.1429
      text = ""
      autoCenter = true
      sizeable = false
      moveable = false
      escExit = false
      maximize = false
      minimize = false
   endwith


   this.PROGRESSBAR1 = new PROGRESSBAR(this)
   with (this.PROGRESSBAR1)
      height = 0.8182
      left = 1
      top = 2.1818
      width = 35
      value = 0
      rangeMin = 0
      rangeMax = 100
   endwith


   this.PERCENT = new TEXT(this)
   with (this.PERCENT)
      height = 0.7727
      left = 36.8571
      top = 2.1818
      width = 4.8571
      alignVertical = 1	// Middle
      alignHorizontal = 1	// Center
      fontName = "MS Sans Serif"
      fontSize = 8
      text = "100 %"
   endwith


   this.TEXT2 = new TEXT(this)
   with (this.TEXT2)
      height = 0.8182
      left = 0.8571
      top = 0.0909
      width = 41
      alignVertical = 1	// Middle
      fontName = "MS Sans Serif"
      fontSize = 8
      text = "Copying:"
   endwith


   this.TXTFILENAME = new TEXT(this)
   with (this.TXTFILENAME)
      height = 0.8182
      left = 1
      top = 1
      width = 41
      alignVertical = 1	// Middle
      fontName = "MS Sans Serif"
      fontSize = 8
      text = "C:\BLAH"
   endwith


   this.btnCancel = new PUSHBUTTON(this)
   with (this.BTNCANCEL)
      onClick = class::BTNCANCEL_ONCLICK
      height = 0.9545
      left = 17
      top = 3.5909
      width = 9.2857
      text = "&Cancel"
      default = true
      fontName = "MS Sans Serif"
      fontSize = 8
      value = false
   endwith


   function form_onOpen
      this.lCancel = .f.
      return

   function btnCancel_onClick
      this.lCancel = .t.
      return
endclass

CLASS PROGRESSBAR(f,n) OF PROGRESS(f, n)
   this.interval = 1
   this.nMax = 0

   PROCEDURE Setup(nMaximum)
   This.nMax = nMaximum
   this.rangeMax = this.nMax
   this.Parent.Percent.Text = '0%'

   PROCEDURE UPDATE(nNum)
   This.nCurrNum = nNum
   this.value = nNum
   this.Parent.Percent.Text = ltrim(str((nNum/this.nMax)*100))+'%'


   PROCEDURE RESET
   This.Parent.Progdisp.Width = .17

ENDCLASS
#else
CLASS progress1 OF FORM
   this.Left = 85.333
   this.Top = 4.6465
   this.Height = 6.5879
   this.Text = "Copying Files"
   this.Width = 52.833
   this.AutoCenter = .T.
   this.Sizeable = .F.
   this.Moveable = .F.
   this.SysMenu = .F.
   this.EscExit = .F.
   this.Maximize = .F.
   this.Minimize = .F.

   DEFINE PROGBAR PROGRESSBAR1 OF THIS;
       PROPERTY;
         Left 1.1641,;
         Top 3.0586,;
         Height 0.9395,;
         Width 43.834

   DEFINE TEXT PERCENT OF THIS;
       PROPERTY;
         Left 46.5,;
         Top 3.0586,;
         Height 0.9404,;
         Text "100%",;
         Width 7,;
         FontBold .F.

   DEFINE TEXT TEXT2 OF THIS;
       PROPERTY;
         Left 1.5,;
         Top 0.4688,;
         Height 0.9395,;
         Text "Copying:",;
         Width 45,;
         Alignment 3,;
         FontBold .F.

   DEFINE TEXT TXTFILENAME OF THIS;
       PROPERTY;
         Left 1.5,;
         Top 1.5293,;
         Height 0.9395,;
         Text "c:\blah",;
         Width 50.1641,;
         Alignment 3,;
         FontBold .F.

   DEFINE PUSHBUTTON btnCancel OF THIS;
       PROPERTY;
         Group .T.,;
         Left 21,;
         Top 4.9404,;
         Height 1.2939,;
         Text "&Cancel",;
         Width 10.833,;
         OnClick CLASS::btnCancel_ONCLICK,;
         Default .T.,;
         FontBold .F.

   DEFINE MENU MAIN OF THIS;
      PROPERTY;
         Text ""

   Procedure Open
   super::Open()
   form.lCancel = .f.
   set procedure to winattr.cc additive
   this.Attr = new winattr(form)
   this.attr.sysmenu(.f.)
   this.attr.minbutton(.f.)
   this.attr.maxbutton(.f.)


   Procedure btnCancel_OnClick
   form.lCancel = .t.

ENDCLASS

Class ProgBar(f,n) of Rectangle(f,n) Custom
   This.height = .93
   This.width = 2
   this.borderstyle = 2
   This.nMax = 0
   This.Interval = 1

   PROCEDURE Setup(nMaximum)
   This.nMax = nMaximum
   if this.nMax <= 100
      This.nInterval = 1
   elseif this.nMax <= 1000
      This.nInterval = 5
   elseif this.nMax <= 10000
      This.nInterval = 20
   else
      This.nInterval = 50
   endif
   this.Parent.Percent.Text = '0%'

   IF type('This.Parent.progdisp') # 'O'

      DEFINE TEXT PROGDISP OF This.Parent;
         Property;
         Text "",;
         FontBold .f.,;
         height this.height-.12,;
         width .17,;
         left this.left+.17,;
         Top this.top+.06,;
         Pageno This.Pageno,;
         ColorNormal "B+/B+"

   endif

   PROCEDURE UPDATE(nNum)
   This.nCurrNum = nNum
   This.TestNum = round(this.nCurrnum/this.nInterval,3)
   *if this.testnum == int(this.testnum)
      This.Parent.Progdisp.visible = .t.
      Local nDecimalDone,nWidth
      nDecimalDone = round(this.nCurrNum/this.nMax,2)
      nWidth = this.width-.35
      if (nDecimaldone*nWidth) > (This.width-.35)
         This.Parent.Progdisp.Width = (This.Width-.35)
      else
         This.Parent.Progdisp.Width = (nDecimalDone*nWidth)
      endif
   *endif
   this.Parent.Percent.Text = ltrim(str((nNum/this.nMax)*100))+'%'


   PROCEDURE RESET
   This.Parent.Progdisp.Width = .17

endclass
#endif

Procedure GetAPI
* Next line commented out unless testing!
* _app.UnlhaAPI_H = null
if type('_app.UnlhaAPI_H') == 'U'
#ifdef __vdb__
extern cword      UnlhaGetVersion(cvoid) unlha32.dll
extern clogical   UnlhaGetRunning(cvoid) unlha32.dll
extern clogical   UnlhaGetBackGroundMode(cvoid) unlha32.dll
extern clogical   UnlhaSetBackGroundMode( clogical) unlha32.dll
extern clogical   UnlhaGetCursorMode(cvoid) unlha32.dll
extern clogical   UnlhaSetCursorMode( clogical ) unlha32.dll
extern cword      UnlhaGetCursorInterval(cvoid) unlha32.dll
extern clogical   UnlhaSetCursorInterval( cword ) unlha32.dll
extern cint       Unlha( chandle, cstring, cstring, clong ) unlha32.dll
extern clogical   UnlhaCheckArchive(cstring, cint ) unlha32.dll
extern cint       UnlhaGetFileCount(cstring ) unlha32.dll
extern clogical   UnlhaQueryFunctionList( cint ) unlha32.dll
extern clogical   UnlhaConfigDialog( chandle, cstring, cint ) unlha32.dll
extern chandle    UnlhaOpenArchive( chandle, cstring, clong) unlha32.dll
extern cint       UnlhaCloseArchive(chandle ) unlha32.dll
extern cint       UnlhaFindFirst(chandle, cstring, cptr) unlha32.dll
extern cint       UnlhaFindNext(chandle, cptr) unlha32.dll
extern cint       UnlhaGetArcFileName(chandle, cstring,  cint) unlha32.dll
extern clong      UnlhaGetArcFileSize(chandle) unlha32.dll
extern clong      UnlhaGetArcOriginalSize(chandle) unlha32.dll
extern clong      UnlhaGetArcCompressedSize(chandle) unlha32.dll
extern cword      UnlhaGetArcRatio(chandle) unlha32.dll
extern cword      UnlhaGetArcDate(chandle) unlha32.dll
extern cword      UnlhaGetArcTime(chandle) unlha32.dll
extern cint       UnlhaGetArcOSType(chandle) unlha32.dll
extern cint       UnlhaIsSFXFile(chandle) unlha32.dll
extern cint       UnlhaGetFileName(chandle, cstring,  cint) unlha32.dll
extern cint       UnlhaGetMethod(chandle, cstring, cint) unlha32.dll
extern clong      UnlhaGetOriginalSize(chandle) unlha32.dll
extern clong      UnlhaGetCompressedSize(chandle) unlha32.dll
extern cword      UnlhaGetRatio(chandle) unlha32.dll
extern cword      UnlhaGetDate(chandle) unlha32.dll
extern cword      UnlhaGetTime(chandle) unlha32.dll
extern clong      UnlhaGetWriteTime(chandle) unlha32.dll
extern clong      UnlhaGetCreateTime(chandle) unlha32.dll
extern clong      UnlhaGetAccessTime(chandle) unlha32.dll
extern clong      UnlhaGetCRC(chandle) unlha32.dll
extern cint       UnlhaGetAttribute(chandle) unlha32.dll
extern cint       UnlhaGetOSType(chandle) unlha32.dll
#else
extern cword    UnlhaGetVersion(cvoid) unlha.dll
extern clogical UnlhaGetRunning(cvoid) unlha.dll
extern clogical UnlhaGetBackGroundMode(cvoid) unlha.dll
extern clogical UnlhaSetBackGroundMode(clogical) unlha.dll
extern clogical UnlhaGetCursorMode(cvoid) unlha.dll
extern clogical UnlhaSetCursorMode(clogical) unlha.dll
extern cword    UnlhaGetCursorInterval(cvoid) unlha.dll
extern clogical UnlhaSetCursorInterval(cword) unlha.dll
extern cint     Unlha(cstring, cstring, cword) unlha.dll
extern clogical UnlhaCheckArchive(cstring, cint) unlha.dll
extern cint     UnlhaGetFileCount(cstring) unlha.dll
extern clogical UnlhaQueryFunctionList(cint) unlha.dll
extern clogical UnlhaConfigDialog(chandle, cstring, cint) unlha.dll
extern chandle  UnlhaOpenArchive(chandle, cstring, clong) unlha.dll
extern cint     UnlhaCloseArchive(chandle) unlha.dll
extern cint     UnlhaFindFirst(chandle, cstring, cptr) unlha.dll
extern cint     UnlhaFindNext(chandle, cptr) unlha.dll
extern cint     UnlhaGetArcFileName(chandle, cptr, cint) unlha.dll
extern clong    UnlhaGetArcFileSize(chandle) unlha.dll
extern clong    UnlhaGetArcOriginalSize(chandle) unlha.dll
extern clong    UnlhaGetArcCompressedSize(chandle) unlha.dll
extern cword    UnlhaGetArcRatio(chandle) unlha.dll
extern cword    UnlhaGetArcDate(chandle) unlha.dll
extern cword    UnlhaGetArcTime(chandle) unlha.dll
extern cint     UnlhaGetArcOSType(chandle) unlha.dll
extern cint     UnlhaGetFileName(chandle, cptr, cint) unlha.dll
extern cint     UnlhaGetMethod(chandle, cptr, cint) unlha.dll
extern clong    UnlhaGetOriginalSize(chandle) unlha.dll
extern clong    UnlhaGetCompressedSize(chandle) unlha.dll
extern cword    UnlhaGetRatio(chandle) unlha.dll
extern cword    UnlhaGetDate(chandle) unlha.dll
extern cword    UnlhaGetTime(chandle) unlha.dll
extern cword    UnlhaGetWriteTime(chandle) unlha.dll
extern cword    UnlhaGetCreateTime(chandle) unlha.dll
extern cword    UnlhaGetAccessTime(chandle) unlha.dll
extern clong    UnlhaGetCRC(chandle) unlha.dll
extern cint     UnlhaGetAttribute(chandle) unlha.dll
extern cint     UnlhaGetOSType(chandle) unlha.dll
#endif
_app.UnlhaAPI_H = .t.
endif